%ext ck1

#Stop Keen hittin ghead sound
%patch $3FD1 $90 $90

#Change battery tile without status screen patch
%patch $1028 $45 $01

#Change lightswitch tile [New tile must have lightswitch propery]
%patch $36D6 $10 $01

#Change tile yorp message head becomes
%patch $455E $45 $00
#And Garg
%patch $188E0 45 $00

#First Yorp message: [Level 2]
%patch 0x015080 "Mortimer says:      "
%patch 0x015096 "                    "
%patch 0x0150AC "Who the heck are you"
%patch 0x0150C2 "and what are you    "
%patch 0x0150D8 "doing here? You'd   "
%patch 0x0150EE "better leave before "
%patch 0x015104 "I get hostile...    "

#Second Yorp message [level 6] -7 lines
%patch 0x01511A "Mortimer smirks:    "
%patch 0x015130 "                    "
%patch 0x015146 "So, you think you're"
%patch 0x01515C "a 314 do you? Well  "
%patch 0x015172 "we'll see how long  "
%patch 0x015188 "you last Bunny Boy. "
%patch 0x01519E "                    "

#Third Yorp message: [level 9] -7 lines
%patch 0x0151B4 "Mortimer snarls:    "
%patch 0x0151CA "                    "
%patch 0x0151E0 "Having fun? I'm     "
%patch 0x0151F6 "surprised you're    "
%patch 0x01520C "still alive, at     "
%patch 0x015222 "least for now...    "
%patch 0x015238 "Muhahaha!           "

#Fourth Yorp message: [Level 10] -7 lines
%patch 0x01524E "Mortimer expouses:  "
%patch 0x015264 "                    "
%patch 0x01527A "Graaagh! I will not "
%patch 0x015290 "be defeated by a kid"
%patch 0x0152A6 "in a rabbit suit!   "
%patch 0x0152BC "I'll deal with you  "
%patch 0x0152D2 "later vermin!!!     "

#Fifth Yorp Message: [level 12] -7 lines
%patch 0x015340 "Mortimer smirks:    "
%patch 0x015356 "                    "
%patch 0x01536C "Hmph! So you figured"
%patch 0x015382 "out my teleporter    "
%patch 0x015399 "maze huh? Nevermind "
%patch 0x0153AF "your pitiful efforts"
%patch 0x0153C5 "are still in vain!  "

#Sixth Yorp message: [level 15] -6 lines
%patch 0x0153DB "Mortimer growls:    "
%patch 0x0153F1 "                    "
%patch 0x015407 "So you want to      "
%patch 0x01541D "rescue 314? Well I  "
%patch 0x015433 "won't be so merciful"
%patch 0x015449 "to you.             "

#Garg message: [level 11] -4 lines
%patch 0x0152E8 "Mortimer jokes:     "
%patch 0x0152FE "                    "
%patch 0x015314 "Boy, this place is  "
%patch 0x01532A "as dim as you are!  "

# Keen does not lose ship parts on dying in their levels. 
%patch 0x4F82 $90 $90 $90 $90 $90 $90 #Joystick
%patch 0x4F8A $90 $90 $90 $90 $90 $90 #Battery
%patch 0x4F92 $90 $90 $90 $90 $90 $90 #Vacum
%patch 0x4F9A $90 $90 $90 $90 $90 $90 #everclear

#Don't show Press F1 for help sprite
%patch $97C9 $90

# The title bitmap will be shown at offset 0,0 
%patch $97B2   $00 $00     # Y location, in pixels 
%patch $97B6   $04 $00     # (X location in pixels) / 8 + 4 

#Start patches
#No id software bitmap
%patch $A248 $90 $90 $90
#of an h pos
%patch  $A233 $00 $00
#sprite for 'of an'
%patch  $A22B $0B
#No production bitmap
%patch $A25A $90 $90 $90
#Presentation h cordinates
%patch  $A221 $0F $00
#Presentation v co ordinates.
%patch  $A21D $30

# yorp movement- left speeds = $FF $FF MINUS desired speed
%patch $18D4 $D2 $FF # [si+20] left speed
%patch $18CD $2E $00 # [si+20] right speed
%patch $19C2 $D2 $FF # [si+20] left speed
%patch $19CE $2E $00 # [si+20] right speed
%patch $1964 $16 $00 # [si+22] yorps jump higher when this is higher
%patch $1A1C $D2 $FF # [si+20] left speed
%patch $1A14 $2E $00 # [si+20] right speed

%patch 0x0001659B "Keen must destroy   "
%patch 0x000165B0 "these parts."

#Give Keen the pogo at the start of every game
%patch $900E  $01 $00

#God Cheat Code- LEV
%patch 0x0120D 0x5052
%patch 0x01214 0x503E
%patch 0x0121B 0x505B
#Text
%patch 0x01500A "INVINCIBILITY!!!"
%patch 0x01501B "Possible death!!!"

#CTSpace Cheat Code - RLZ
%patch 0x011F5 0x503F
%patch 0x011FC 0x5052
%patch 0x01203 0x5058
#Text
%patch 0x014DEE "Resorting to cheating"
%patch 0x014E05 "how absolutely pathetic!  "
%patch 0x014E21 "REAL players don't use"
%patch 0x014E39 "cheats you slime mould! "

#Menu text
%patch 0x015EF6 "Restore  Game"
%patch 0x015F12 "About Me..."
%patch 0x015F22 "The Keenest"
%patch 0x015F32 "             "
#Make  Ordering info  have no effect.
%patch $95A3  $EB $AD

#Pogo stops when Keen hits the ground.
%patch $409B $90 $90
#Pogo acts as an antigravity boots
%patch $3F50  $90
%patch $3F4E  $90

# Change the teleporter so it works within the level (updated 24/09/03) 
%patch $8919                           $89 $F0 $F7 $2E $08 $6C $01 
   $F8 $D1 $E0 $C4 $1E $4C $6C $01 $C3 $26 $8B $07 $50 $88 $E0 $98 
   $99 $01 $F0 $83 $D2 $00 $B1 $0C $E8 $16 $58 $89 $16 $E4 $6E $A3 
   $E2 $6E $05 $00 $B0 $83 $D2 $FF $A3 $D4 $6E $89 $16 $D6 $6E $58 
   $98 $99 $01 $F8 $83 $D2 $00 $B1 $0C $E8 $F5 $57 $89 $16 $E0 $6E 
   $A3 $DE $6E $05 $00 $70 $83 $D2 $FF $A3 $D0 $6E $89 $16 $D2 $6E 
   $C3 
%patch $4572  $E8 $A4 $43 $EB $13 $90 

#Vorticon strength
%patch $180D  $09 $00

#Tileinfo
%patchfile 0x130F8 ball.CK1

#Keen 3 tile patch
%patch $4409      $26 $8B $07 $B6 $0D $F6 $FE 
%patch $4410  $F6 $EE $26 $89 $07 $E9 $60 $01 
%patch $4482  $E9 $74 $FF 
%patch $44BA  $E9 $3C $FF 
%patch $4513  $E9 $E3 $FE 
%patch $28EC                  $26 $8B $07 $B6 
%patch $28F0  $0D $F6 $FE $F6 $EE $26 $89 $07 
%patch $28F8  $03 $1E $08 $6C $03 $1E $08 $6C 
%patch $2900  $26 $89 $07 $90 $90 $90 $90 $90 

#Birder colors
%patch $4A62   $05 
%patch $6F9D   $38
%patch $15568  $38 
%patch $15579  $05 
%patch $1558A  $3D 
%patch $1559B  $05 
%patch $4A7D $04 
%patch $4A85 $3C

#Butler bot speed
%patch $17A5  $90

#Disable map clipping when imortal
%patch $A626  $EB 

#Exit
#Top blank tile doesn't appear
%patch $417E $90
#Bottom blank tile doesn't appear
%patch $41A7 $90
#Keen exit door tile 1
%patch $4128 $2C $01
#and tile 2
%patch $414C $2C $01

#Highscore table item tiles
%patch $992A  $C0 $01
%patch $995D  $C1 $01
%patch $9990  $C2 $01
%patch $99C3  $C3 $01

#Keen must find menu tiles
%patch $AE78  $C0 $01 
%patch $AE9D  $C1 $01 
%patch $AEC2  $C2 $01 
%patch $AEE7  $C3 $01 

#Show only 6 names in Keenest
%patch $9A18   $06 

# Show the score with white background 
%patch $99FA   $E8 $D5 $C8        # CALL    62D2 
#Ditto name
%patch $9A10   $E8 $BF $C8        # CALL    62D2 

#Raygun gives 4 shots
%patch $44A4  $04

# Change the controls to: Space, shoot; Enter, status. 
#http://andy.durdin.net/keen/modding/viewtopic.php?t=433
%patch $1251  $48 
%patch $7FA3  $48 
%patch $3B23  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $3C4E  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $3DB9  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $3DCC  $90 $90 
%patch $3E6D  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $3FFC  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 

#Status window text
%patch 0x014E52 "    SCORE     EXTRA SPIFF AT"
%patch 0x014E73 "    KEENS    DESTROYED PARTS"
%patch 0x014E9A " RAYGUN   BOOTS     KEYS    "
%patch 0x014EC7 " CHARGES "
%patch 0x014ED9 " WHAT ARE YOU WAITING FOR?  "

###
#TEXT
###

%patch 0x015F80 "Hi I am Adriael, a long-time Keen "
%patch 0x015FA8 "fan and a new mod-maker. Big     "
%patch 0x015FD0 "thanks to all those whose     "
%patch 0x015FF8 "graphics and stuff  "
%patch 0x016020 "contributed to this mod. To     "
%patch 0x016048 "everyone else, enjoy the game and  "
%patch 0x016070 "watch out for the next    "
%patch 0x016098 "episodes comming soon! "
%patch 0x0160C0 "Hey Apogee! release Keen 7   "
%patch 0x0160E8 "now before I come over there and "
%patch 0x016110 "recolour your palette!   "

#Set the window sizes
#Eighth textbox bottom
%patch $877C $18 $00
#Eighth Keens house textbox right side
%patch $8780 $1D $00
#Eighth Keens house textbox top
%patch $8784 $12 $00
#Eighth Keens house textbox left side
%patch $8788 $04 $00
#First Keens house textbox bottom
%patch $8546 $18 $00
#First Keens house textbox right side
%patch $854A $1D $00
#First Keens house textbox top
%patch $854E $12 $00
#Length textbox appears [AFTER text stops writing!]
%patch $857A $2C $01
#Second textbox bottom
%patch $85D5 $18 $00
#Second Keens house textbox right side
%patch $85D9 $1D $00
#Second Keens house textbox top
%patch $85DD $12 $00

#Now fiddle the misc stuff:
#Pause between exiting and ending sequence [teh black screen]
%patch $820D $2C $00
#Teh text appearance speed! [higher = slower ]
%patch $8173 $05 $00
#No ? appears
%patch $8404 $32 $00
#No ! appears
%patch $8481 $32 $00
#Stop 3rd textbox appearing
%patch $8635 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90
#Stop 4th textbox appearing
%patch $867B $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90
#Stop 5th textbox appearing
%patch $86AF $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
#Stop 6th textbox appearing
%patch $86EC $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90
#Stop 7th textbox appearing
%patch $8714 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90
#Window x location
%patch $8596 $04 $00
#Dark Window x location
%patch $85B9 $04 $00
#Window x location
%patch $8622 $04 $00
#Window x location
%patch $874F $04 $00
#Window x location
%patch $8772 $04 $00
#Rocket sprite shown on Earth
%patch $87FD $1E $00
#How long ship stays on Earth
%patch $8819 $01 $00
#Sprite for rocket going to vortiship
%patch $8857 $1E $00
#Sprite for rocket LANDED on vortiship
%patch $8892 $1E $00
#Pause between ship landing and To be cont sign
%patch $88AB $3C $00

#Finally alter all the text:
%patch 0x015C24 "Freeing Commander Keen, Spiff heads"
%patch 0x015C49 "for home. Another galaxy saved by"
%patch 0x015C6C "the amazing Spaceman Spiff!        "
%patch $15C91 $0A $00
# First dialogue box at home
%patch 0x015CBD "Spiff returns home to "
%patch 0x015CD5 "read comics and   "
%patch 0x015CE9 "stay up late.    "
#Second
%patch 0x015CFB "But where is Keen? "
%patch 0x015D10 "his ship is missing"
%patch 0x015D25 "...       "
#Eigth 
%patch 0x015E07 "It was last seen near"
%patch 0x015E1E "the mysterious ship    "
%patch 0x015E37 "looming above Earth"
%patch 0x015E4C "What has happened to "
%patch 0x015E63 "our hero?     "

%end
